<template>
  <div class="contents">
    <div class="contents_wrap">
      <div class="top_wrap">
        <h3 class="title">발신번호 관리</h3>
        <p class="breadcrumb">발신번호관리 &gt; 발신번호 관리</p>
      </div>
      <div class="search_wrap">
        <div class="group">
          <div class="select_box">
            <label for="right" class="label">승인상태</label>
            <select name="" id="sttusCd" v-model="searchType1" @keyup.enter="search">
              <option value="">전체</option>
              <option value="01">승인대기</option>
              <option value="02">승인완료</option>
              <option value="03">반려</option>
            </select>
          </div>
          <div class="select_box">
            <label for="right" class="label">명의자 구분</label>
            <select name="" id="nmineeDivCd" v-model="searchType2" @keyup.enter="search">
              <option value="">전체</option>
              <option value="01">사업자</option>
              <option value="02">타사업자</option>
            </select>
          </div>
          <div class="select_box">
            <label for="right" class="label">인입채널</label>
            <select name="" id="inchDivCd" v-model="searchType3" @keyup.enter="search">
              <option value="">전체</option>
              <option value="01">홈페이지</option>
              <option value="02">어드민</option>
            </select>
          </div>
          <div class="select_box id">
            <label for="right" class="label">상세검색</label>
            <select name="" id="category" v-model="searchType4" @keyup.enter="search">
              <option value="regNo">발신번호</option>
              <option value="bregNo">사업자번호</option>
              <option value="custNm">고객사명</option>
            </select>
          </div>
          <div class="input_box">
            <input
              class="search-box"
              type="text"
              id="search"
              placeholder="검색어 입력"
              v-model.trim="grid.params.searchText1"
              maxlength="100"
              @keyup.enter="search"
            />
          </div>
          <button type="button" class="button grey" @click="search">조회</button>
        </div>
      </div>
      <div class="info">
        <div class="count">
          총 <span>{{ totalItems.toString().replace(/\B(?=(\d{3})+(?!\d))/g, ',') }}</span
          >건
          <div class="select_box NumberSe">
            <select name="" id="perPage" v-model="perPageCnt" @change="changePerPage()">
              <option value="20">20</option>
              <option value="50">50</option>
              <option value="100">100</option>
            </select>
          </div>
        </div>
        <div class="button_group">
          <button type="button" class="button blue add" @click="numberRegPopOpen()">등록</button>
          <button type="button" class="button white del" @click="deleteNumber()">삭제</button>
        </div>
      </div>
      <div class="table">
        <custom-grid
          ref="table"
          :totalItems="'totalItems'"
          :url="grid.url"
          :pagePerRows="grid.pagePerRows"
          :initialRequest="grid.initialRequest"
          :pagination="grid.pagination"
          :isCheckbox="grid.isCheckbox"
          :columns="grid.columns"
          :noDataStr="grid.noDataStr"
          :addCls="grid.addCls"
          :header="grid.headder"
          :pageRange="grid.pageRange"
        ></custom-grid>
      </div>

      <number-reg-pop ref="numberRegPop"></number-reg-pop>
      <number-detail-pop ref="numberDetailPop" />
      <common-modal ref="commmonModal"></common-modal>
    </div>
  </div>
</template>

<script>
import customGrid from '@/components/CustomGrid';
import commonModal from '@/components/modal/commonModal';
import NumberRegPop from '../components/NumberRegPop';
import NumberDetailPop from '@/modules/sendNumMgt/components/NumberDetailPop';
import sendNumMgtApi from '../service/sendNumMgtApi';

class CustomATagRenderer {
  constructor(props) {
    this.props = props;
    const el = document.createElement('a');
    el.href = 'javascript:void(0);';
    el.className = 'btn_text';
    el.innerText = String(props.colValue);
    this.el = el;
  }

  getElement() {
    return this.el;
  }

  addEvent(selEl) {
    selEl.addEventListener('click', () => {
      const { callback } = this.props['cgrido' + this.props.colName].options;
      callback(this.props);
    });
  }
}

export default {
  name: 'numberList',
  data() {
    return {
      row: {},
      authType: [],
      statType: [],
      cate2Code: '',
      totalItems: 0,
      searchType4: 'regNo',
      searchType3: '',
      searchType2: '',
      searchType1: '',
      isFirst: true,
      // 테이블 리스트 데이터
      perPageCnt: 50,
      grid: {
        url: '/api/v1/bo/sendNumMgt/numberList',
        pagePerRows: 20,
        pagination: true,
        isCheckbox: true,
        initialRequest: false,
        addCls: 'box_OFvis',
        pageRange: 1,
        header: [
          [
            { header: 'No', childNames: [] },
            { header: '고객사명', childNames: [] },
            { header: '관리자ID', childNames: [] },
            { header: '등록자ID', childNames: [] },
            { header: '사업자번호', childNames: [] },
            { header: '명의자 구분', childNames: [] },
            { header: '인입채널', childNames: [] },
            { header: '발신번호', childNames: [] },
            { header: '승인상태', childNames: [] },
            { header: '등록일자', childNames: [] },
          ],
        ],

        columns: [
          { name: 'no', header: 'No', align: 'center', width: '5%' },
          { name: 'regReqNo', hidden: true },
          { name: 'bizrAuthYn', hidden: true },
          { name: 'custNm', header: '고객사명', align: 'center', width: '5%' },
          { name: 'adminId', header: '관리자ID', align: 'center', width: '10%' },
          { name: 'register', header: '등록자ID', align: 'center', width: '10%' },
          { name: 'bregNo', header: '사업자번호', align: 'center', width: '10%' },
          { name: 'nmineeDivCd', header: '명의자 구분', align: 'center', width: '10%' },
          { name: 'inchDivCd', header: '인입채널', align: 'center', width: '10%' },
          {
            name: 'sndrno',
            header: '발신번호',
            align: 'center',
            width: '10%',
            renderer: {
              type: CustomATagRenderer,
              options: {
                callback: this.numberDetail,
              },
            },
          },
          { name: 'sttusCd', header: '승인상태', align: 'center', width: '10%' },
          { name: 'regDt', header: '등록일자', width: '10%', cls: 'td_line' },
        ],
        noDataStr: '검색 결과가 없습니다.',
        params: {
          searchType1: '',
          searchType2: '',
          searchType3: '',
          searchType4: '',
          searchText1: '',
          pagePerRows: '',
          page: '',
        },
        excelHeader: [],
      },
    };
  },
  components: {
    customGrid: customGrid,
    NumberRegPop,
    NumberDetailPop,
    commonModal,
  },
  created() {
    // this.grid.pagePerRows = 50
    this.isFirst = true;
  },
  destroyed() {
    this.$store.commit('searchcondition/updateSearchCondition', {
      page: 1,
      perPage: 50,
      params: {
        searchType1: '',
        searchType2: '',
        searchType3: '',
        searchType4: '',
        searchText1: '',
      },
    });
  },
  mounted() {
    let page = 1;
    // 페이지 정보 및 검색 조건
    const getCondition = this.$store.getters['searchcondition/getSearchCondition'];

    // store에 저장된 페이지 정보 및 검색 조건을 불러오기
    let isKeep = false;
    if (getCondition) {
      this.grid.pagePerRows = getCondition.perPage;
      this.grid.params = getCondition.params;
      page = getCondition.page;
      isKeep = true;
    }
    this.search(isKeep);
  },
  methods: {
    search: function (isKeep) {
      this.grid.params.searchType1 = this.searchType1;
      this.grid.params.searchType2 = this.searchType2;
      this.grid.params.searchType3 = this.searchType3;
      this.grid.params.searchType4 = this.searchType4;
      if (this.isFirst) {
        this.grid.pagePerRows = 50;
      }
      this.$refs.table.search(this.grid.params, isKeep);
      this.sendStoreData();
      this.isFirst = false;
    },
    sendStoreData: function () {
      const getP = this.$refs.table.getPagination();
      this.$store.commit('searchcondition/updateSearchCondition', {
        page: getP._currentPage,
        perPage: this.perPageCnt,
        params: this.grid.params,
      });
    },
    numberRegPopOpen: function () {
      this.$refs.numberRegPop.numberRegPopopen();
    },
    numberDetail(props) {
      this.$refs.numberDetailPop.numberDetailPopOpen(props);
    },
    commonModalOpen(row) {
      this.$refs.commmonModal.alertModalOpen(row);
    },
    deleteNumber() {
      if (this.doValidate()) {
        this.row.title = '문자발신번호 관리';
        this.row.msg1 = '삭제 하시겠습니까?';
        this.$refs.commmonModal.confirmModalOpen2(this.row);
      }
    },
    async numberDelete() {
      try {
        let response = await sendNumMgtApi.deleteNumber(this.row);
        const result = response.data;
        if (result != null && result.retCode == '0000') {
          this.$refs.table.reloadData();
          return;
        } else {
          this.row.title = '문자발신번호 관리';
          this.row.msg1 = '실패 하였습니다.';
          this.$refs.commmonModal.alertModalOpen(this.row);
        }
      } catch (err) {
        this.row.title = '문자발신번호 관리';
        this.row.msg1 = '실패 하였습니다.';
        this.$refs.commmonModal.alertModalOpen(this.row);
      }
    },
    doValidate() {
      //로우데이터 삭제하도록 수정

      if (this.totalItems == 0) {
        this.row.title = '문자발신번호 관리';
        this.row.msg1 = '검색 결과가 없습니다.';
        this.$refs.commmonModal.alertModalOpen(this.row);
        return false;
      }
      var chkList = this.$refs.table.checkedElementDatas();
      if (chkList.length == 0) {
        this.row.title = '문자발신번호 관리';
        this.row.msg1 = '삭제대상을 체크를 해주세요.';
        this.$refs.commmonModal.alertModalOpen(this.row);
        return false;
      }
      //const param = chkList.map((row)=>({regReqNo:row.regReqNo} ));
      const param = chkList.map((row) => ({ seqNo: row.seqNo }));
      this.row.list = param;
      return true;
    },
    confirmCalbackFnc(props) {
      if (props.result) {
        this.numberDelete();
      }
    },
    changePerPage: function () {
      // 페이지당 조회할 개수
      this.grid.pagePerRows = this.perPageCnt;
    },
  },
  beforeRouteLeave(to, from, next) {
    const getP = this.$refs.table.getPagination();
    this.$store.commit('searchcondition/updateSearchCondition', {
      page: getP._currentPage,
      perPage: this.perPageCnt,
      params: this.grid.params,
    });
    // 라우트 하기전 실행
    next();
  },
};
</script>
